const https = require('https');
const app = require('j7/app');
const utils = require('j7/utils');
const http = require('j7/http');
const serviceFactory = require('../services/factory');

async function get(session) {
  const seqId = session.request('seq_id');
  const targetUrl = session.request('target_url');
  const cbUrl = session.request('cb_url');
  const reqJson = session.requestToJson();
  new Promise(async (resolve) => {
    const params = utils.jsonDecode(session.request('params'));
    const {err, data} = await http.get(targetUrl, params);
    const rspJson = {
      'errcode': 0,
      'errmsg': '',
      'seq_id': seqId,
      'req_json': reqJson,
      'data': data
    };
    if (err) {
      rspJson['errcode'] = 1;
      rspJson['errmsg'] = '' + err;
    }
    console.log('data', data);
    console.log('rspJson:' + utils.jsonEncode(rspJson));
    await http.get(cbUrl, rspJson);
  });
  session.rspOk();
};

async function post(session) {
}

function init() {
  app.registerHandler('Proxy', 'get', get);
  app.registerHandler('Proxy', 'post', post);
}

exports.init = init;
