package main

import "f5"
import "mt"

const (
	MT_SERVER_INFO = 0
	MT_CONF = iota
	MT_MAX = iota
)

type MetaMgr struct {
	f5.MetaMgr
}

func (this *MetaMgr) Init() *MetaMgr {
	this.MetaMgr.Init()
	configDir := "../config/"
	if !f5.IsOnlineEnv() {
		configDir = "/var/data/conf_test/statserver/"
	}
	metaClasses := &[]f5.MetaClass{
		f5.MetaClass{
			PrimKey: "InstanceId",
			FileName: configDir + "statserver.cluster.json",
			Idx: MT_SERVER_INFO,
			RawMeta: (*mt.ServerInfoMetas)(nil),
			WrapMeta: (*MtwServerInfo)(nil)},
		f5.MetaClass{
			FileName: configDir + "statserver.json",
			Idx: MT_CONF,
			RawMeta: (*mt.ConfMetas)(nil),
			WrapMeta: (*MtwConf)(nil)},
		}
	this.MetaMgr.RegisterMetaClasses(metaClasses)
	this.Load()
	return this
}

func (this *MetaMgr) UnInit() {
	this.MetaMgr.UnInit()
}

func (this *MetaMgr) GetServer(instance_id int32) *MtwServerInfo {
	v, ok := this.MetaMgr.GetMetaById(MT_SERVER_INFO, instance_id).(*MtwServerInfo)
	if ok {
		return v
	} else {
		return nil
	}
}

func (this *MetaMgr) GetConf() *MtwConf {
	v, ok := this.MetaMgr.GetMetaById(MT_CONF, 1).(*MtwConf)
	if ok {
		return v
	} else {
		return nil
	}
}
