package main

import (
	"q5"
	"f5"
)

type GameLog struct {

}

func (this *GameLog) Init() *GameLog {
	f5.TgLog().SetPolyLog(true)
	return this
}

func (this *GameLog) UnInit() {
}

func (this *GameLog) PlayerOnline(remoteAddr string, accountId string, registerTime int64) {
	gameId := f5.ExtractGameIdFromAccountId(accountId)
	channel := f5.ExtractChannelFromAccountId(accountId)

	prop := q5.NewMxoObject()
	prop.SetXValue("channel", q5.NewXInt32(channel))
	prop.SetXValue("ad_channel", q5.NewXString(""))
	prop.SetXValue("account_register_date", q5.NewXString(q5.FormatUnixDateTime(registerTime)))
	prop.SetXValue("gameid", q5.NewXInt32(gameId))

	f5.TgLog().AddTrackLog(gameId, accountId, remoteAddr, 21, 1, prop.AsXObject())
}

func (this *GameLog) PlayerOffline(remoteAddr string, accountId string, registerTime int64, onlineTime int64) {
	gameId := f5.ExtractGameIdFromAccountId(accountId)
	channel := f5.ExtractChannelFromAccountId(accountId)

	prop := q5.NewMxoObject()
	prop.SetXValue("channel", q5.NewXInt32(channel))
	prop.SetXValue("ad_channel", q5.NewXString(""))
	prop.SetXValue("account_register_date", q5.NewXString(q5.FormatUnixDateTime(registerTime)))
	prop.SetXValue("gameid", q5.NewXInt32(gameId))

	prop.SetXValue("online_time", q5.NewXString(q5.FormatUnixDateTime(onlineTime)))
	prop.SetXValue("online_duration", q5.NewXInt64(f5.App.NowUnix() - onlineTime))

	f5.TgLog().AddTrackLog(gameId, accountId, remoteAddr, 21, 2, prop.AsXObject())
}
